
<?php
// ClanSphere 2007 - www.clansphere.net
// $Id: $

$cs_lang = cs_translate('updates');

global $cs_db;
$error = 0;
$actions = '';
$sql_content = '';

if(isset($_FILES['update']['name']) AND preg_match("=^(.*?)\.sql$=si",$_FILES['update']['name'])) {
	$sql_content = file_get_contents($_FILES['update']['tmp_name']);
}
elseif(!empty($_POST['text'])) {
	$sql_content = $_POST['text'];
}

if(!empty($sql_content)) {

	$sql_update = str_replace('{time}',cs_time(),$sql_content);
	if($cs_db['type'] == 'mysql') {
		$sql_update = str_replace('{optimize}','OPTIMIZE TABLE',$sql_update);
		$sql_update = str_replace('{serial}','int(8) unsigned NOT NULL auto_increment',$sql_update);
		$sql_update = str_replace('{engine}',' TYPE=MyISAM',$sql_update);
    $sql_update = preg_replace("=create index (\S+) on (\S+) (\S+)=si",'ALTER TABLE $2 ADD KEY $1 $3',$sql_update);
	}
	elseif($cs_db['type'] == 'mysqli' OR $cs_db['type'] == 'pdo_mysql') {
		$sql_update = str_replace('{optimize}','OPTIMIZE TABLE',$sql_update);
		$sql_update = str_replace('{serial}','int(8) unsigned NOT NULL auto_increment',$sql_update);
		$sql_update = str_replace('{engine}',' ENGINE=MyISAM',$sql_update);
    $sql_update = preg_replace("=create index (\S+) on (\S+) (\S+)=si",'ALTER TABLE $2 ADD KEY $1 $3',$sql_update);
	}
	elseif($cs_db['type'] == 'pgsql' OR $cs_db['type'] == 'pdo_pgsql') {
		$sql_update = str_replace('{optimize}','VACUUM',$sql_update);
		$sql_update = str_replace('{serial}','serial NOT NULL',$sql_update);
		$sql_update = str_replace('{engine}','',$sql_update);
		$sql_update = preg_replace("=int\((.*?)\)=si",'integer',$sql_update);
	}
	elseif($cs_db['type'] == 'mssql') {
		$sql_update = str_replace('{serial}','int IDENTITY(1,1)',$sql_update);
		$sql_update = str_replace('{engine}','',$sql_update);
		$sql_update = preg_replace("=int\((.*?)\)=si",'int',$sql_update);
	}
	elseif($cs_db['type'] == 'sqlite' OR $cs_db['type'] == 'pdo_sqlite') {
		$sql_update = str_replace('{optimize}','VACUUM',$sql_update);
		$sql_update = str_replace('{serial}','integer',$sql_update);
		$sql_update = str_replace('{engine}','',$sql_update);
		$sql_update = preg_replace("=int\((.*?)\)=si",'integer',$sql_update);
	}

  global $com_lang;
	$sql_array = explode(';',$sql_update);
	foreach($sql_array AS $sql_query) {
		$sql_query = trim($sql_query);
		if(!empty($sql_query)) {
			if($check = cs_sql_query(__FILE__, $sql_query)) {
				$para[1] = 'green';
				$info = $check['affected_rows'];
			}
			else {
				$para[1] = 'red';
				$info = $cs_db['last_error'];
				$error++;
			}
			$para[2] = nl2br(htmlentities($sql_query, ENT_QUOTES, $com_lang['charset']));
			$actions .= cs_abcode_color($para);
			$actions .= ' # ' . $info;
			$actions .= cs_html_br(1);
		}
	}
}
else {
	$error++;
}

echo cs_html_table(1,'forum',1);
echo cs_html_roco(1,'headb');
echo $cs_lang['mod'] . ' - ' . $cs_lang['import'];
echo cs_html_roco(0);
echo cs_html_roco(1,'leftc');
if(empty($_FILES['update']['tmp_name'])) {
	echo $cs_lang['body_import'];
}
elseif(empty($error)) {
	echo $cs_lang['update_done'];
}
else {
	echo $cs_lang['update_error'];
}
echo cs_html_roco(0);
echo cs_html_table(0);
echo cs_html_br(1);

if(!empty($actions)) {

	echo cs_html_table(1,'forum',1);
	echo cs_html_roco(1,'centerc');
	echo $cs_lang['actions_done'];
	echo cs_html_roco(0);
	echo cs_html_roco(1,'leftb');
	echo $actions;
	echo cs_html_roco(0);
	echo cs_html_table(0);
	echo cs_html_br(1);
}

if(empty($sql_content) OR !empty($error)) {

  echo cs_html_form(1,'updates_roots','updates','import',1);
  echo cs_html_table(1,'forum',1);

	echo cs_html_roco(1,'leftc');
	echo cs_icon('kate') . $cs_lang['sql_text'];
	echo cs_html_roco(2,'leftb');
	echo cs_html_textarea('text',$sql_content,'50','12');
	echo cs_html_roco(0);

  echo cs_html_roco(1,'leftc');
  echo cs_icon('download') . $cs_lang['sql_file'];
  echo cs_html_roco(2,'leftb');
  echo cs_html_input('update','','file');
  echo cs_html_roco(0);

	echo cs_html_roco(1,'leftc');
  echo cs_icon('ksysguard') . $cs_lang['options'];
  echo cs_html_roco(2,'leftb');
  echo cs_html_vote('submit',$cs_lang['run'],'submit');
  echo cs_html_roco(0);
	echo cs_html_table(0);
	echo cs_html_form(0);
}
else {
	echo cs_html_table(1,'forum',1);
	echo cs_html_roco(1,'centerb');
	echo cs_link($cs_lang['continue'],'updates','roots');
	echo cs_html_roco(0);
	echo cs_html_table(0);
}

?>