<?php
// ClanSphere 2007 - www.clansphere.net
// $Id: $

function cs_looptemplate($source,$string,$data) {

	foreach($data AS $subname => $subdata) {
		if(empty($subdata) OR isset($subdata[0]) AND is_array($subdata[0])) {
			$pattern = "=(.*){loop:" . $subname . "}(.*?){stop:" . $subname . "}(.*)=si";
			$content = array();
			preg_match_all($pattern, $string , $content);
			if(isset($content[1][0]) AND isset($content[2][0]) AND isset($content[3][0])) {
				$string = $content[1][0];
				if(!empty($subdata)) {
					foreach($subdata as $loopdata) {
						$new_content = cs_conditiontemplate($content[2][0],$loopdata);
						foreach($loopdata AS $name => $value) {
              if (!is_array($value)) {
						    $new_content = str_replace('{' . $subname . ':' . $name . '}', $value, $new_content);
              } else {
                $array = array($name => $value);
                $new_content = cs_looptemplate($source, $new_content, $array);
              }
						}
						$string .= $new_content;
					}
				}
				$string .= $content[3][0];
			} else {
				cs_error($source,'cs_subtemplate - Loop not found: "' . $subname . '"');
			}
		} elseif(is_array($subdata)) {
			foreach($subdata AS $name => $value) {
				$string = str_replace('{' . $subname . ':' . $name . '}', $value, $string);
			}
		}
	}
  return $string;
}

function cs_conditiontemplate ($string, $data) {
  
  if (!isset($data['if'])) {
    return $string;
  }

  foreach ($data['if'] as $condition => $value) {
    $replace = empty($value) ? '' : "\\1";
    $string = preg_replace("={if:".$condition."}(.*?){stop:".$condition."}=si",$replace,$string);
  }

  return $string;
}

function cs_templateurl($matches) {
  
  $more = empty($matches[3]) ? 0 : str_replace(',','&amp;',$matches[3]);

  return cs_url($matches[1],$matches[2], $more);
}

function cs_subtemplate($source,$data,$mod,$action = 'list',$navfiles = 0) {

	global $cs_main;
	$target = 'themes/' . $cs_main['def_theme'] . '/' . $mod . '/' . $action . '.tpl';
  if($cs_main['def_theme'] != 'base' AND !file_exists($target)) {
      cs_warning('cs_subtemplate - Custom theme file not found: "' . $target . '"');
      $target = 'themes/base/' . $mod . '/' . $action . '.tpl';
  }
	if(!file_exists($target)) {
		cs_error($source, 'cs_subtemplate - Theme file not found: "' . $target . '"');
    return FALSE;
	}

	$string = file_get_contents($target);
	$string = str_replace('{page:width}', $cs_main['def_width'], $string);
	$string = str_replace('{page:self}', $_SERVER['PHP_SELF'], $string);
	$string = str_replace('{page:path}', $cs_main['php_self']['dirname'], $string);
	$string = str_replace('{page:mod}', $cs_main['mod'], $string);
	$string = preg_replace_callback("={icon:(.*?)}=i",'cs_icon',$string);
	$string = cs_conditiontemplate($string,$data);
	$string = cs_looptemplate($source,$string,$data);
  $string = preg_replace_callback("={lang:(.*?)}=i",'cs_templatelang',$string);
  $string = preg_replace_callback('={url:(.*?)_(.*?),(.*?)}=i','cs_templateurl',$string);
  $string = preg_replace_callback('={url:(.*?)_(.*?)}=i','cs_templateurl',$string);

  if(!empty($navfiles))
    $string = preg_replace_callback("={(?!func)(.*?):(.*?)(:(.*?))*}=i",'cs_templatefile',$string);

	return $string;
}

function cs_templatefile($matches) {

  $file = 'mods/'.$matches[1].'/'.$matches[2].'.php';
  if (!file_exists($file)) {
    cs_error($file,'cs_templatefile - File not found');
    return $matches[0];
  }
  if (!empty($matches[3])) {
    $data = explode('=', substr($matches[3],1));
    $backup = empty($_GET[$data[0]]) ? '' : $_GET[$data[0]];
    $_GET[$data[0]] = $data[1];
    $return = cs_filecontent($file);
    if (!empty($backup)) $_GET[$data[0]] = $backup;
    return $return;
  }
  return cs_filecontent($file);
}

function cs_filecontent($file) {

  global $account, $cs_main;

  ob_start();
  include $file;
  $content = ob_get_contents();
  ob_end_clean();

  return $content;
}

function cs_templatelang($matches) {

  global $cs_lang;

  return !empty($cs_lang[$matches[1]]) ? $cs_lang[$matches[1]] : $matches[0];
}

function cs_getmsg() {
  
  if (!isset($_SESSION['message']) || empty($_SESSION['message']))
    return '';
  
  $string  = cs_html_table(1,'forum',1);
  $string .= cs_html_roco(1,'centerb');
  $string .= $_SESSION['message'];
  $string .= cs_html_roco(0);
  $string .= cs_html_table(0);
  $string .= cs_html_br(1);
  
  unset($_SESSION['message']);
  
  return $string;
  
}

function cs_redirect($message, $mod, $action = 'manage', $more = 0) {
  
  $_SESSION['message'] = $message;
  $url = str_replace('&amp;','&',cs_url($mod,$action,$more));
  header('Location: ' . $url);
  exit();
  
}

function cs_template($cs_micro,$cs_main,$account,$tpl_file = 'index.htm') {

  global $cs_logs, $com_lang;
  $wp = $cs_main['php_self']['dirname'];
  $mod = $cs_main['mod'];
  $action = $cs_main['action'];
  $get_axx = 'mods/' . $mod . '/access.php';

  if(!file_exists($cs_main['show'])) {
    $message = 'cs_template - File not found';
		cs_error($cs_main['show'],$message);
		$cs_main['show'] = 'mods/errors/404.php';
  } elseif(!file_exists($get_axx)) {
    $message = 'cs_template - Access file not found';
		cs_error($get_axx,$message);
    $cs_main['show'] = 'mods/errors/403.php';
  } else {
    $axx_file = array();
    include($get_axx);
    if(!isset($axx_file[$action])) {
      $message = 'cs_template - No access defined for target file';
		  cs_error($cs_main['show'],$message);
      $cs_main['show'] = 'mods/errors/403.php';
    }
    elseif(!isset($account['access_' . $mod])) {
      $message = 'cs_template - No module access defined in database';
		  cs_error($cs_main['show'],$message);
      $cs_main['show'] = 'mods/errors/403.php';
    }
    elseif($account['access_' . $mod] < $axx_file[$action]) {
			$cs_main['show'] = empty($account['users_id']) ? 'mods/users/login.php' : 'mods/errors/403.php';
    }
  }

  if((empty($cs_main['public']) OR $tpl_file == 'admin.htm') AND $account['access_clansphere'] < 3) {
    $cs_main['show'] = 'mods/users/login.php';
    $tpl_file = 'login.htm';
  }

    if($account['access_clansphere'] < 4) {
        $cs_main['template'] = $cs_main['def_tpl'];
    }
	$tpl_path = 'templates/' . $cs_main['template'];
	if(!file_exists($tpl_path  . '/' . $tpl_file)) {
		cs_error($tpl_path . '/' . $tpl_file,'cs_template - Template not found');
		die('Template not found: ' . $tpl_path  . '/' . $tpl_file);
	}
    $cs_temp_get = file_get_contents($tpl_path . '/' . $tpl_file);
    $tpl_path = $wp . $tpl_path;

    $pattern = "=\<link(.*?)href\=\"(?!http)(.*?)\"(.*?)\>=i";
	$cs_temp_get = preg_replace($pattern,"<link\\1href=\"" . $tpl_path . "/\\2\"\\3>", $cs_temp_get);
    $pattern = "=background\=\"(?!http)(.*?)\"=i";
	$cs_temp_get = preg_replace($pattern,"background=\"" . $tpl_path . "/\\1\"", $cs_temp_get);
	$pattern = "=src\=\"(?!http)(.*?)\"=i";
	$cs_temp_get = preg_replace($pattern,"src=\"" . $tpl_path . "/\\1\"", $cs_temp_get);
	$script  = "<script src=\"" . $wp . "system/javascript/clansphere.js\" type=\"text/javascript\"></script>\r\n";  
	$script .= "<script src=\"" . $wp . "system/javascript/ajax.js\" type=\"text/javascript\"></script>\r\n";  
    $cs_temp_get = str_replace('</head>',$script . '</head>', $cs_temp_get);
  
    $content = str_replace(array('{','}'),array('&#123;','&#125;'),cs_filecontent($cs_main['show']));
    $cs_temp_get = str_replace('{func:show}',$content,$cs_temp_get);
    $cs_temp_get = preg_replace_callback("={(?!func)(.*?):(.*?)(:(.*?))*}=i",'cs_templatefile',$cs_temp_get);

    $cs_main['def_title'] = htmlspecialchars($cs_main['def_title'], ENT_QUOTES);
    $cs_temp_get = str_replace('{func:title}', $cs_main['def_title'], $cs_temp_get);
    $cs_temp_get = str_replace('{func:charset}', $com_lang['charset'], $cs_temp_get);
    $cs_temp_get = str_replace('{func:queries}', $cs_logs['queries'], $cs_temp_get);
    $cs_logs['errors'] = nl2br($cs_logs['errors']);
    $cs_temp_get = str_replace('{func:errors}', $cs_logs['errors'], $cs_temp_get);
    $cs_logs['sql'] = nl2br(htmlspecialchars($cs_logs['sql'], ENT_QUOTES));
    $cs_temp_get = str_replace('{func:sql}', $cs_logs['sql'], $cs_temp_get);
    $getparse = cs_parsetime($cs_micro);
    $cs_temp_get = str_replace('{func:parse}', $getparse, $cs_temp_get);
    $getmemory = function_exists('memory_get_usage') ? cs_filesize(memory_get_usage()) : '-';
    $cs_temp_get = str_replace('{func:memory}', $getmemory, $cs_temp_get);

	return $cs_temp_get;
}

?>